<template>
  <div class="overview">
    <!-- First Row -->
    <b-row id="selectBoxes">
      <!-- Project -->
      <b-col>
        <CoscineFormGroup
          label-for="ProjectName"
          :label="$t('form.project.projectNameLabel')"
          :is-loading="!project"
          type="input"
        >
          <b-form-input
            v-if="project"
            id="ProjectName"
            v-model="project.displayName"
            :readonly="readonly"
            :disabled="readonly"
            required
          />
        </CoscineFormGroup>
      </b-col>

      <!-- Resource Dropdown -->
      <b-col>
        <CoscineFormGroup
          label-for="Resource"
          :label="$t('page.settings.overview.resourceLabel')"
          :is-loading="!resource"
        >
          <b-form-select
            v-if="resource"
            id="Resource"
            v-model="selectedResource"
            :options="allResources"
            value-field="id"
            text-field="displayName"
            @update:model-value="switchResource"
          >
            <template #first>
              <b-form-select-option :value="undefined" disabled>
                {{ $t("page.settings.overview.resourceSelect") }}
              </b-form-select-option>
            </template>
          </b-form-select>
        </CoscineFormGroup>
      </b-col>
    </b-row>

    <!-- Second Row -->
    <b-row>
      <!-- Resource Name -->
      <b-col>
        <CoscineFormGroup
          label-for="ResourceNameReadOnly"
          :label="$t('form.resource.resourceNameLabel')"
          :is-loading="!resource"
        >
          <b-form-input
            v-if="resource"
            id="ResourceNameReadOnly"
            v-model="resource.name"
            required
            :readonly="readonly"
            :disabled="readonly"
          />
        </CoscineFormGroup>
      </b-col>

      <!-- Persistent ID -->
      <b-col>
        <CoscineFormGroup
          label-for="PersistentId"
          :label="$t('page.settings.overview.persistentIdLabel')"
          :is-loading="!resource"
          info
        >
          <template #popover>
            {{ $t("page.settings.overview.persistentIdPopover") }}
            <b-link
              :href="
                $t('page.settings.overview.persistentIdPopoverUrl').toString()
              "
              target="_blank"
            >
              {{ $t("default.help") }}
            </b-link>
          </template>

          <b-button-group class="w-100">
            <!-- Text Field -->
            <b-form-input
              v-if="resource"
              id="PersistentId"
              v-model="resource.pid"
              class="rounded-end-0"
              required
              :readonly="readonly"
              :disabled="readonly"
            />

            <!-- Copy Button -->
            <b-button
              id="copyPidButton"
              v-b-tooltip.click.top="
                $t('page.settings.configuration.toClipboard', {
                  resourceOption: $t('page.settings.overview.persistentId'),
                })
              "
              class="rounded-end-2"
              @click="copyPid"
            >
              <i-bi-clipboard />
            </b-button>
          </b-button-group>
        </CoscineFormGroup>
      </b-col>
    </b-row>

    <!-- Third Row -->
    <b-row>
      <!-- Resource Type -->
      <b-col>
        <CoscineFormGroup
          label-for="ResourceType"
          :label="$t('page.settings.overview.resourceTypeLabel')"
          :is-loading="!resource"
          type="input"
        >
          <b-form-input
            v-if="resource && resource.type"
            id="ResourceType"
            :model-value="
              $t('resourceTypes.' + resource.type.specificType + '.displayName')
            "
            required
            :readonly="readonly"
            :disabled="readonly"
          />
        </CoscineFormGroup>
      </b-col>

      <!-- Resource Quota -->
      <b-col>
        <CoscineFormGroup
          v-if="resource && usedQuota !== null && reservedQuota !== null"
          label-for="Quota"
          :label="$t('page.settings.overview.quotaLabel')"
          :is-loading="!(resource && usedQuota >= 0 && usedQuota !== null)"
        >
          <b-button-group class="progressContainer h-100 w-100">
            <!-- Progress Bar -->
            <b-progress
              :max="reservedQuota"
              height="inherit"
              class="w-100 border-1 border-secondary-subtle rounded-end-0 light"
            >
              <b-progress-bar
                :value="usedQuota"
                :variant="
                  usedQuota / reservedQuota >= 0.8 ? 'danger' : 'primary'
                "
              >
                <span>
                  <strong
                    :class="
                      usedQuota / reservedQuota < 0.5
                        ? 'justify-content-center d-flex position-absolute w-100 text-body'
                        : ''
                    "
                  >
                    {{ formatBytes(usedQuota) }} /
                    {{ formatBytes(reservedQuota) }}
                  </strong>
                </span>
              </b-progress-bar>
            </b-progress>

            <!-- Quota Page -->
            <b-button v-if="isOwner" :to="{ name: 'project-quota' }">
              <i-bi-gear />
            </b-button>
          </b-button-group>
        </CoscineFormGroup>
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts">
// import the store for current module
import useResourceStore from "../../store";
import useProjectStore from "@/modules/project/store";
import { FileUtil } from "../../utils/FileUtil";
import type { RouteLocationRaw } from "vue-router";
import type {
  ProjectDto,
  ResourceDto,
  ResourceTypeInformationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import { QuotaUnit, VisitedResourceObject } from "../../types";

export default defineComponent({
  components: {},
  setup() {
    const resourceStore = useResourceStore();
    const projectStore = useProjectStore();

    return { resourceStore, projectStore };
  },

  data() {
    return {
      readonly: true,
      selectedResource: undefined as string | undefined,
      conversionFactor: Math.pow(1024, 3), // Byte <-> GB
    };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    resource(): VisitedResourceObject | null {
      return this.resourceStore.currentResource;
    },
    isOwner(): boolean | undefined {
      return this.projectStore.currentUserRoleIsOwner;
    },
    allResources(): ResourceDto[] {
      return this.projectStore.currentResources ?? [];
    },
    resourceTypeInformation(): ResourceTypeInformationDto | undefined {
      return this.resourceStore.enabledResourceTypes?.find(
        (resourceType) => resourceType.id === this.resource?.type?.id,
      );
    },
    usedQuota(): number | null {
      if (
        this.resourceStore.currentResourceQuota &&
        this.resourceStore.currentResourceQuota.used
      ) {
        return FileUtil.convertCapacityUnits(
          this.resourceStore.currentResourceQuota.used,
          QuotaUnit.Byte,
        ); // value is in Bytes
      } else return null;
    },
    reservedQuota(): number | null {
      if (
        this.resourceStore.currentResourceQuota &&
        this.resourceStore.currentResourceQuota.reserved
      ) {
        return FileUtil.convertCapacityUnits(
          this.resourceStore.currentResourceQuota.reserved,
          QuotaUnit.Byte,
        ); // value is in Bytes
      } else return null;
    },
  },

  watch: {
    resource() {
      this.onResourceLoaded();
    },
  },

  created() {
    // Fill the resource form
    this.onResourceLoaded();
  },

  methods: {
    onResourceLoaded() {
      if (this.project?.id && this.resource) {
        this.selectedResource = this.resource.id;
        if (
          !this.resourceStore.currentResourceQuota &&
          this.resourceTypeInformation?.isQuotaAvailable
        ) {
          // Retrieve quota only if the resource has quota available (e.g. skip for Linked Resource)
          this.resourceStore.retrieveResourceQuota(
            this.project.id,
            this.resource,
          );
        }
      }
    },
    copyPid() {
      if (this.resource) {
        navigator.clipboard.writeText(
          "http://hdl.handle.net/" + this.resource.pid,
        );
      }
    },
    switchResource(id: string) {
      const route = {
        name: "resource-settings",
        params: { guid: id },
      } as RouteLocationRaw;
      const url = this.$router.resolve(route).href;
      window.location.href = url;
    },
    formatBytes(bytes: number) {
      return FileUtil.formatBytes(bytes);
    },
  },
});
</script>

<style scoped>
.progressContainer :deep(.progress) {
  height: auto !important;
}
.progressContainer :deep(strong) {
  margin-top: -0.6rem;
}
</style>
